<template>
  <gpa-notification :loading="loading"
                    :notification-id="notification.id"
                    :created-at="notification.createdAt"
                    :archived-at="notification.archivedAt"
                    :map-name="title.mapName"
                    :map-id="title.mapId"
                    icon="users"
                    :deletable="notification.type !== 'TeamMateInviteNotification'">
    <template #title>
      <i18n-t :keypath="title.translation">
        <template #username>
          <strong>{{ notification.sender.username }}</strong>
        </template>
        <template #map>
          <em>{{ title.mapName }}</em>
        </template>
      </i18n-t>
    </template>

    <rui-toolbar v-if="notification.type === 'TeamMateInviteNotification'">
      <rui-button :caption="$t('js.notifications.action.accept')" icon="check" variant="creative" @click="acceptTeamMateInvitation" />
      <rui-button :caption="$t('js.notifications.action.refuse')" icon="x-bold" variant="destructive" @click="refuseTeamMateInvitation" />
    </rui-toolbar>
  </gpa-notification>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'
import GpaNotification from './_Notification.vue'

import Toaster from '../../../../tools/Toaster'
import Notification from '../../../../classes/models/Notification'

export default {
  name: 'GpaTeamMateNotification',
  components: { RuiButton, RuiToolbar, GpaNotification },
  props: {
    notification: { required: true, type: [Notification, Object] },
  },
  data () {
    return {
      loading: false,
    }
  },
  computed: {
    title () {
      switch (this.notification.type) {
        case 'TeamMateAcceptNotification':
          return {
            // i18n-tasks-use t('js.notifications.messages.team_mate_accept')
            translation: 'js.notifications.messages.team_mate_accept',
            mapName: this.notification.subject.map.name,
            mapId: this.notification.subject.map_id,
          }
        case 'TeamMateInviteNotification':
          return {
            // i18n-tasks-use t('js.notifications.messages.team_mate_invitation')
            translation: 'js.notifications.messages.team_mate_invitation',
            mapName: this.notification.subject.map.name,
            mapId: this.notification.subject.map_id,
          }
        case 'TeamMateLeaveNotification':
          return {
            // i18n-tasks-use t('js.notifications.messages.team_mate_leave')
            translation: 'js.notifications.messages.team_mate_leave',
            mapName: this.notification.subject.name,
            mapId: this.notification.subject.id,
          }
        case 'TeamMateRefuseNotification':
          return {
            // i18n-tasks-use t('js.notifications.messages.team_mate_refuse')
            translation: 'js.notifications.messages.team_mate_refuse',
            mapName: this.notification.subject.name,
            mapId: this.notification.subject.id,
          }
        case 'TeamMateRemoveNotification':
          return {
            // i18n-tasks-use t('js.notifications.messages.team_mate_remove')
            translation: 'js.notifications.messages.team_mate_remove',
            mapName: this.notification.subject.name,
            mapId: this.notification.subject.id,
          }
        default:
          return {
            // i18n-tasks-use t('js.notifications.messages.unhandled_notification_type')
            translation: 'js.notifications.messages.unhandled_notification_type',
          }
      }
    },
  },
  methods: {
    handleAction (promise) {
      this.loading = true
      return promise.then().catch().then(() => { this.loading = false })
    },
    acceptTeamMateInvitation () {
      this.handleAction(this.$store.dispatch('acceptTeamMateInvitation', { id: this.$props.notification.subjectId, notificationId: this.$props.notification.id }))
        .then(() => { Toaster.success(this.$t('js.team_mates.successfully_accepted')) })
    },
    refuseTeamMateInvitation () {
      this.handleAction(this.$store.dispatch('acceptTeamMateInvitation', this.$props.notification.subjectId))
        .then(() => {
          this.$store.dispatch('destroyNotification', this.$props.notification.id)
          Toaster.success(this.$t('js.team_mates.successfully_refused'))
        })
    },
  },
}
</script>
